#!/bin/sh

#
#  Test the log processing of gcm_daemon
#  Create a database with one object and read a piece of sendmail log
#
#  This tests problem report nrs. 14 through 17

LD_LIBRARY_PATH=/usr/local/pqxx/lib
export LD_LIBRARY_PATH

cd ..

if psql gnucomo_test -q <src/database/create.sql >/dev/null
then
   #  Prepare the database

   psql gnucomo_test -q -c "insert into object (objectname) values ('schiza.andromeda.nl')"

   #  read logs for both objects

   src/gcm_input/gcm_input -c gnucomo_test -h schiza.andromeda.nl -d 'oct 26 2003 20:30:45' <test/log0010

   # Test gcm_daemon
   cd src/gcm_daemon; ./gcm_daemon.php -c gnucomo_test; cd ../..

   # Check the notifications.

   psql gnucomo_test -c "select notificationid,objectid,type_of_issueid from notification"

   #  Clean up.

   psql gnucomo_test -f src/database/destroy.sql -q

   exit 0
else
   echo Can not create test database
   exit 1
fi
